<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:template match="/">
<html>
<head>
<style type='text/css'>
<![CDATA[
table{font-size: 7pt; font-family: Verdana;}
select{font-size: 7pt; font-family: Verdana;}
.filterPanel
{
	border-collapse: collapse;
	position:relative;
	left:0;
	top:3;
	visibility:visible;
	border-right: lightgrey 1px solid;
	border-top: lightgrey 1px solid;
	border-left: lightgrey 1px solid;
	border-bottom: lightgrey 1px solid;
}

.filterHeader
{
	font-weight: bolder;
	background-color: beige;
	border-right: black 1px solid;
	border-top: black 1px solid;
	border-left: black 1px solid;
	border-bottom: black 1px solid;
}

.logPanel
{
	border-collapse: collapse;
	left: 50;
	border-right: lightgrey 1px solid;
	border-top: lightgrey 1px solid;
	border-left: lightgrey 1px solid;
	border-bottom: lightgrey 1px solid;
}
.entryTable
{
	border-collapse: collapse;
	border-right: lightgrey 1px solid;
	border-top: lightgrey 1px solid;
	border-left: lightgrey 1px solid;
	border-bottom: lightgrey 1px solid;
}
.entryTableLeft
{
	border-collapse: collapse;
	border-right: lightgrey 1px solid;
	border-top: lightgrey 1px solid;
	border-bottom: lightgrey 1px solid;
}
.entryTableRight
{
	border-collapse: collapse;
	
	border-top: lightgrey 1px solid;
	border-left: lightgrey 1px solid;
	border-bottom: lightgrey 1px solid;
}
.awTable
{
	border-collapse: collapse;
}
.entryTableHeader
{
	border-right: lightgrey 1px solid;
	border-top: lightgrey 1px solid;
	border-left: lightgrey 1px solid;
	border-bottom: lightgrey 1px solid;
	background-color: beige;
}
.entryTableHeaderLeft
{
	border-right: lightgrey 1px solid;
	border-top: lightgrey 1px solid;
	border-bottom: lightgrey 1px solid;
	background-color: beige;
}
.entryTableHeaderRight
{
	border-top: lightgrey 1px solid;
	border-left: lightgrey 1px solid;
	border-bottom: lightgrey 1px solid;
	background-color: beige;
}

]]>
</style>
<script>
<![CDATA[
var bPinned;
function init()
{
	bPinned = true;
	
	var aAllTableRows = document.getElementsByTagName('tr');
	var len =  aAllTableRows.length;
	for(var i = 0; i < len; i++)
	{
		var trCurr = aAllTableRows[i];
		if(trCurr.getAttribute('sessionRow') == 'yes')
		{
			performSessionInternal(trCurr.firstChild.firstChild);
		}
	}
	
}

function mouseEnter()
{
	var srcElem = event.srcElement;
	var srcElem = event.srcElement;
 	var strImgPath = srcElem.getAttribute('src');
 	var elemSessionRow = srcElem.parentNode.parentNode;
 	var strImg = '-_hover.gif';
 	if(elemSessionRow.nextSibling.style.display == 'none')
	{
		strImg = '+_hover.gif';
	}
	switchImage(strImg,srcElem);
}

function mouseLeave()
{
 	var srcElem = event.srcElement;
 	var strImgPath = srcElem.getAttribute('src');
 	var elemSessionRow = srcElem.parentNode.parentNode;
 	var strImg = '-.gif';
 	if(elemSessionRow.nextSibling.style.display == 'none')
	{
		strImg = '+.gif';
	}
	switchImage(strImg,srcElem);
}

function performSessionInternal(srcElem)
{
	var elemSessionRow = srcElem.parentNode.parentNode;
	var nDataCount = parseInt(elemSessionRow.getAttribute('dataCount'));
	var strDisplay = '';
	var strImg = '-.gif';
	if(elemSessionRow.nextSibling.style.display == '')
	{
		strDisplay = 'none';
		strImg = '+.gif';
	}
	if(nDataCount > 0)
	{
		var nCount = 0;
		while(nCount < (nDataCount+1))
		{
			elemSessionRow.parentNode.childNodes[elemSessionRow.rowIndex+1+nCount].style.display = strDisplay;	
			nCount++;
		}
	}
	switchImage(strImg,srcElem);
}

function performSession()
{
	var srcElem = event.srcElement;
	performSessionInternal(srcElem);
}

function switchImage(strImg, elemImg)
{
	var strImgPath = elemImg.getAttribute('src');
	strImgPath = getCorrectImgPath(strImgPath, strImg);
	elemImg.setAttribute('src',strImgPath);
}

function movePanel()
{
	var pos;
	if (window.innerHeight)
	{
		  pos = window.pageYOffset
	}
	else if (document.documentElement && document.documentElement.scrollTop)
	{
		pos = document.documentElement.scrollTop
	}
	else if (document.body)
	{
		  pos = document.body.scrollTop
	}
	pos = pos -3;
	if(pos > 0) pnlFilter.style.top = pos;
}
function panelPerform()
{
	var elemImg = event.srcElement;
	var elemHeader = elemImg.parentNode.nextSibling;
	var elemPanel = elemImg.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.nextSibling.firstChild;
	var strDisplay = '';
	var strPinGif = 'pin.gif';
	bPinned = true;
	if(elemHeader.style.display == '')
	{
		// Unpin
		strDisplay = 'none';
		strPinGif = 'unpin.gif';
		bPinned = false;
	}
	elemHeader.style.display = strDisplay;
	elemPanel.style.display = strDisplay;
	switchImg(strPinGif,elemImg);
}

function getCorrectImgPath(strOldImgPath,strNewImg)
{
	var nLastSep = strOldImgPath.lastIndexOf('/');
	strOldImgPath = strOldImgPath.substring(0,nLastSep+1);
	return strOldImgPath + strNewImg;
}


function showHoverImg()
{
	var elemImg = event.srcElement;
	var strImg = 'unpin_hover.gif'
	if(bPinned) strImg = 'pin_hover.gif';
	switchImage(strImg,elemImg);
}

function hideHoverImg()
{
	var elemImg = event.srcElement;
	var strImgPath = elemImg.getAttribute('src');
	var strPinGif = 'unpin.gif';
	if(bPinned)	strPinGif = 'pin.gif';
	elemImg.setAttribute('src',getCorrectImgPath(strImgPath, strPinGif));
}


function appendMessage(strWho, strWhereLoc, strWhereLink, strWhen, strParam1, strParam2, strParam3)
{
	//var body = document.getElementsByTagName('body')[0];
	var aAllTblRows = document.getElementsByTagName('tr');
	var trLast;
	var i = aAllTblRows.length;
	while(i--)
	{
		var trCurr = aAllTblRows[i];
		if(trCurr.getAttribute('sessionRow') == 'yes')
		{
			trLast = trCurr;
			break;
		}
	}
	var nDataCount = parseInt(trLast.getAttribute('dataCount'));
	nDataCount++;
	trLast.setAttribute('dataCount',nDataCount+'');
	
	var tblLog = document.getElementById('pnlLog');
	
	var trNew = document.createElement('tr');
	
	var tdWho = document.createElement('td');
	var tdWhat = document.createElement('td');
	var tdWhere = document.createElement('td');
	var tdWhen = document.createElement('td');
	
	tdWho.innerHTML = strWho;
	tdWhat.innerHTML = strParam1+','+strParam2+','+strParam3;
	var anchor = document.createElement('a');
	anchor.setAttribute('href',strWhereLink);
	anchor.innerHTML = strWhereLoc;
	tdWhere.appendChild(anchor);
	tdWhen.innerHTML = strWhen;
	
	trNew.appendChild(tdWho);
	trNew.appendChild(tdWhat);
	trNew.appendChild(tdWhere);
	trNew.appendChild(tdWhen);
	
	tdWho.className = 'entryTableLeft';
	tdWhat.className = 'entryTable';
	tdWhere.className = 'entryTable';
	tdWhen.className = 'entryTableRight';
	
	tblLog.firstChild.appendChild(trNew);
	window.scroll(0,trNew.offsetTop+trNew.height);
	
}

]]>
</script>
</head>
<body onLoad="init();" onScroll="movePanel();">
<xsl:for-each select="no.jabber.eclipseplugin.serialization.AwarenessData">

<table>
<tbody>
<tr>
<td rowspan="4" valign="top">
<!--<div id="pnlFilter">-->
<!-- Start filter-->
	<table id="pnlFilter" class="filterPanel" ><tbody>
	<tr><td class='filterHeader'><table><tbody><tr><td><img onClick="panelPerform();" onMouseEnter="showHoverImg();" onMouseLeave="hideHoverImg();" src="pin.gif"/></td><td><b>Filter</b></td></tr></tbody></table></td></tr>
	<tr><td colspan="2">
		<table><tbody>
			<tr><td>Not</td></tr>
			<tr><td>
				<select>
					<option>implemented</option>
				</select>
			</td></tr>
			<tr><td>yet!</td></tr>
			<tr><td>
				<select>
					<option>=)</option>
				</select>
			</td></tr>
		</tbody></table>
	</td></tr>
	</tbody></table>
<!-- End filter-->
<!--</div>-->
</td>
</tr>
<tr><td valign='top'>Log created: <xsl:value-of select="Created"/></td></tr>
<tr><td valign='top'>Log last saved: <xsl:value-of select="Created"/></td></tr>
<tr>
<td valign='top'>
<!-- Start awareness-listing -->
<xsl:for-each select="Sessions">
<table id="pnlLog" class="logPanel" cellpadding='0'>
<tbody align='justify'>
<xsl:for-each select="no.jabber.eclipseplugin.serialization.AwarenessSession">
<tr sessionRow='yes'>
	<xsl:attribute name='dataCount'><xsl:value-of select="count(./Entries/no.jabber.eclipseplugin.serialization.AwarenessEntry)"/></xsl:attribute>
	<td colspan='4'><img onClick='performSession();' onMouseEnter='mouseEnter();' onMouseLeave='mouseLeave();' src='+.gif'/><xsl:value-of select='Entries/no.jabber.eclipseplugin.serialization.AwarenessEntry[count(./Entries/no.jabber.eclipseplugin.serialization.AwarenessEntry)]/When'/></td>
</tr>
<tr><td class='entryTableHeaderLeft'>Who</td><td class='entryTableHeader'>What</td><td class='entryTableHeader'>Where</td><td class='entryTableHeaderRight'>When</td></tr>
<xsl:for-each select="Entries/no.jabber.eclipseplugin.serialization.AwarenessEntry">
<tr>
	<td class='entryTableLeft'><xsl:value-of select="Who"/></td>
	<td class='entryTable'>
		<xsl:for-each select="What/string">
			<xsl:value-of select="."/><xsl:text>,</xsl:text>
		</xsl:for-each>
	</td>
	<td class='entryTable'>
		<a>
			<xsl:attribute name='href'><xsl:value-of select="Where"/></xsl:attribute>
			<xsl:value-of select="substring(Where,20)"/>
		</a>
	</td>
	<td class='entryTableRight'><xsl:value-of select="When"/></td>
</tr>
</xsl:for-each>
</xsl:for-each>
</tbody>
</table>
</xsl:for-each>
<!-- End awareness-listing -->
</td>
</tr>
</tbody>
</table>

</xsl:for-each>
</body>
</html>
</xsl:template>
</xsl:stylesheet>

  