<?xml version='1.0' encoding='UTF-8' ?>
<xsl:stylesheet version='1.0' xmlns:xsl='http://www.w3.org/1999/XSL/Transform'>
<xsl:template match='/'>
<html>
<head>
<style type='text/css'>
<![CDATA[

table{font-size: 7pt; font-family: Verdana;}
select{font-size: 7pt; font-family: Verdana;}
.filterPanel
{
	border-collapse: collapse;
	position:relative;
	left:0;
	top:3;
	visibility:visible;
	border-right: lightgrey 1px solid;
	border-top: lightgrey 1px solid;
	border-left: lightgrey 1px solid;
	border-bottom: lightgrey 1px solid;
}

.filterHeader
{
	font-weight: bolder;
	background-color: beige;
	border-right: black 1px solid;
	border-top: black 1px solid;
	border-left: black 1px solid;
	border-bottom: black 1px solid;
}
.chatLog
{
	border-collapse: collapse;
}
.msgDiv
{
	border-right: lightgrey 1px solid;
	border-top: lightgrey 1px solid;
	border-left: lightgrey 1px solid;
	border-bottom: lightgrey 1px solid;
}

.msgsFromMe
{
	color: #3300ff;
}
.plMiColumn
{
	vertical-align:top;
	cursor: hand;
}
]]>
</style>
<script type='text/javascript' language='javascript'>
<![CDATA[
var bPinned;
var aMsgDivs;
function init()
{
	bPinned = true;
	document.getElementById('sessionTemplate').style.display = 'none';
	var elem = document.getElementsByTagName('body')[0]; 
	var aDivs = elem.getElementsByTagName('div'); 
	var lstContexts = document.getElementById('lstContexts');
	aMsgDivs = new Array();
	for(var i = 0; i < aDivs.length; i++)
	{
		var currDiv = aDivs[i];
		if(currDiv.getAttribute('msgDiv') == 'yes') 
		{
			aMsgDivs.push(currDiv);
			var opt = document.createElement('option');
			var strCtx = currDiv.getAttribute('context');
			opt.setAttribute('value',strCtx);
			opt.innerHTML = strCtx;
			lstContexts.appendChild(opt);
		}
	}
	for(var j = 0; j < aMsgDivs.length; j++)
	{
		var elemPluss = aMsgDivs[j].childNodes[0].childNodes[0].childNodes[0].childNodes[0].childNodes[1].childNodes[0];
		aMsgDivs[j].childNodes[0].childNodes[0].childNodes[0].childNodes[0].childNodes[0].style.display = 'none';
		showHideChatSessionInternal(elemPluss);
	}
	//aMsgDivs[aMsgDivs.length-1].childNodes[0].childNodes[0].childNodes[0].childNodes[0].childNodes[0].style.display = 'none';
	
	showAllContexts();
	document.getElementById('rdoShowAll').status = true;
	window.scroll(0,aMsgDivs[aMsgDivs.length-1].offsetTop+aMsgDivs[aMsgDivs.length-1].offsetHeight);
}

function getMessageDiv(strContext)
{
	var theDiv = null;
	for(var j = 0; j < aMsgDivs.length; j++)
	{
		var d = aMsgDivs[j];
		var strCurrContext = d.getAttribute('context');
		if(strCurrContext.toUpperCase() == strContext.toUpperCase())
		{
			theDiv = d;
			break;
		}
	}
	if(theDiv == null)
	{
		// create new div...
		var tmpl = document.getElementById('sessionTemplate');
		theDiv = tmpl.cloneNode(true);
		theDiv.style.display = '';
		theDiv.setAttribute('id','');
		theDiv.setAttribute('msgDiv','yes');
		theDiv.setAttribute('context',strContext);
		document.getElementById('sessionRow').appendChild(theDiv);
		theDiv.childNodes[0].childNodes[0].childNodes[0].childNodes[0].childNodes[0].style.display = 'none';
		var stamp = new Date();
		theDiv.childNodes[0].childNodes[0].childNodes[0].childNodes[0].childNodes[2].innerHTML = 'Context: '+ strContext +', Location: none, '+ stamp.toLocaleString();
		aMsgDivs.push(theDiv);
		var lstContexts = document.getElementById('lstContexts');
		var opt = document.createElement('option');
		opt.setAttribute('value',strContext);
		opt.innerHTML = strContext;
		lstContexts.appendChild(opt);
	}
	return theDiv;
}

function appendMessage(strName,strMsg,strContext,strTimestamp)
{ 
	var elemLastMsgDiv = getMessageDiv(strContext);
	var trNew = document.createElement('tr');
	elemLastMsgDiv.childNodes[1].childNodes[0].childNodes[0].appendChild(trNew);
	if(strName == '$me') trNew.className = 'msgsFromMe';
	var tdName = document.createElement('td');
	tdName.innerHTML = strName;
	var tdColon = document.createElement('td');
	tdColon.innerHTML = ':';tdColon.setAttribute('align','right');
	var tdMsg = document.createElement('td');
	tdMsg.innerHTML = strMsg;
	tdMsg.setAttribute('title','Message received: ' + strTimestamp);
	trNew.appendChild(tdName);
	trNew.appendChild(tdColon);
	trNew.appendChild(tdMsg);
	window.scroll(0,elemLastMsgDiv.offsetTop+elemLastMsgDiv.offsetHeight);
}
function showHideChatSessionInternal(elemPluss)
{
	
	var elemToHide = elemPluss.parentNode.parentNode.parentNode.parentNode.parentNode.nextSibling;
	var strVisible = 'none';
	var strImgPath = elemPluss.getAttribute('src');
	if(elemPluss.parentNode.previousSibling.innerHTML == '-')	
	{
		elemPluss.parentNode.previousSibling.innerHTML = '+';
		strImgPath = getCorrectImgPath(strImgPath,'+.gif');
		//elemPluss.setAttribute('src','+.gif');
	}
	else 
	{
		elemPluss.parentNode.previousSibling.innerHTML = '-';
		strVisible = '';
		strImgPath = getCorrectImgPath(strImgPath,'-.gif');
		//elemPluss.setAttribute('src','-.gif');
	}
	elemPluss.setAttribute('src',strImgPath);
	elemToHide.style.display = strVisible;
	
}
function showHideChatSession()
{
	var elemPluss = event.srcElement;
	showHideChatSessionInternal(elemPluss);
}

function panelPerform()
{
	var elemImg = event.srcElement;
	var elemHeader = elemImg.parentNode.nextSibling;
	var elemPanel = elemImg.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.nextSibling.firstChild;
	var strDisplay = '';
	var strPinGif = 'pin.gif';
	bPinned = true;
	if(elemHeader.style.display == '')
	{
		// Unpin
		strDisplay = 'none';
		strPinGif = 'unpin.gif';
		bPinned = false;
	}
	elemHeader.style.display = strDisplay;
	elemPanel.style.display = strDisplay;
	switchImg(strPinGif,elemImg);
}

function switchImage(strImg, elemImg)
{
	var strImgPath = elemImg.getAttribute('src');
	strImgPath = getCorrectImgPath(strImgPath, strImg);
	elemImg.setAttribute('src',strImgPath);
}

function clearLog()
{
	alert('Clear!');
}
function deleteSession()
{
	alert('Delete!');
}

function getCorrectImgPath(strOldImgPath,strNewImg)
{
	var nLastSep = strOldImgPath.lastIndexOf('/');
	strOldImgPath = strOldImgPath.substring(0,nLastSep+1);
	return strOldImgPath + strNewImg;
}
function showHoverImg()
{
	var elemImg = event.srcElement;
	var strImg = 'unpin_hover.gif'
	if(bPinned) strImg = 'pin_hover.gif';
	switchImage(strImg,elemImg);
}

function hideHoverImg()
{
	var elemImg = event.srcElement;
	var strImgPath = elemImg.getAttribute('src');
	var strPinGif = 'unpin.gif';
	if(bPinned)	strPinGif = 'pin.gif';
	elemImg.setAttribute('src',getCorrectImgPath(strImgPath, strPinGif));
}
function movePanel()
{
	var pos;
	if (window.innerHeight)
	{
		  pos = window.pageYOffset
	}
	else if (document.documentElement && document.documentElement.scrollTop)
	{
		pos = document.documentElement.scrollTop
	}
	else if (document.body)
	{
		  pos = document.body.scrollTop
	}
	pos = pos -3;
	if(pos > 0) pnlFilter.style.top = pos;
}
function mouseEnter()
{
	var elemStatus = event.srcElement.parentNode.parentNode.firstChild;
	var elemHover = event.srcElement;
	var strImgPath = elemHover.getAttribute('src');
	if(elemStatus.innerHTML == '-')
	{
		// Show minus hover
		//alert();
		strImgPath = getCorrectImgPath(strImgPath,'-_hover.gif');
	}
	else
	{
		// Show pluss hover
		strImgPath = getCorrectImgPath(strImgPath,'+_hover.gif');
	}
	elemHover.setAttribute('src',strImgPath);
}
function mouseLeave()
{
	var elemStatus = event.srcElement.parentNode.parentNode.firstChild;
	var elemHover = event.srcElement;
	var strImgPath = elemHover.getAttribute('src');
	if(elemStatus.innerHTML == '-')
	{
		// Show minus 
		strImgPath = getCorrectImgPath(strImgPath,'-.gif');
	}
	else
	{
		// Show pluss 
		strImgPath = getCorrectImgPath(strImgPath,'+.gif');
	}
	elemHover.setAttribute('src',strImgPath);
}

function showAllContexts()
{
	var lstContexts = document.getElementById('lstContexts');
	lstContexts.disabled = true;
	var len = aMsgDivs.length;
	for(var i = 0; i < len; i++)
	{
		aMsgDivs[i].style.display = '';
	}
}

function filterContexts()
{
	var lstContexts = document.getElementById('lstContexts');
	lstContexts.disabled = false;
	var aSelCtxs = new Array();
	var htSelCtxs = {};
	var aOpts = lstContexts.options;
	var len = aOpts.length;
	for(var i = 0; i < len; i++)
	{
		var optCurrent = aOpts[i];
		if(optCurrent.selected == true) 
		{
			//aSelCtxs.push(optCurrent);
			htSelCtxs[optCurrent.getAttribute('value')] = optCurrent;
		}
	}
	//alert(aSelCtxs.length);
	var len2 = aMsgDivs.length;
	for(var j = 0; j < len2; j++)
	{
		if(htSelCtxs[aMsgDivs[j].getAttribute('context')] == null)
		{
			aMsgDivs[j].style.display = 'none';
		}
		else
		{
			aMsgDivs[j].style.display = '';
		}
	}
}
]]>
</script>
</head>
<body onload='init();' onScroll='movePanel();'>
<!-- Session template -->
<div id='sessionTemplate' msgDiv='template' context='context'>
				<div>
					<table class='chatLog' cellpadding='0'><tbody>
					<tr>
						<td>-</td><td class='plMiColumn' UNSELECTABLE='on'><img onClick='showHideChatSession();' onMouseEnter='mouseEnter();' onMouseLeave='mouseLeave();' src='-.gif'/></td>
						<td class='chatHeaders'>Context: context, Location: loc, timestamp</td>
					</tr>
					</tbody></table>
				</div>
				<div class='msgDiv'>
				<table class='chatLog' cellpadding='0'><tbody>
					<tr>
						<!--
						<td>from</td>
						<td align='right'>:</td>
						<td title='Message received: timestamp'>message</td>
						-->
					</tr>
				</tbody></table>
				</div>
</div>
<!-- end session template -->

	<xsl:for-each select='no.jabber.eclipseplugin.serialization.LogData'>
	<table><tbody>
	<tr><td rowspan="3" valign="top">
	<!-- Start filter-->
		<table id="pnlFilter" class="filterPanel" ><tbody>
		<tr><td class='filterHeader'><table><tbody><tr><td><img onClick="panelPerform();" onMouseEnter="showHoverImg();" onMouseLeave="hideHoverImg();" src="pin.gif"/></td><td><b>Filter</b></td></tr></tbody></table></td></tr>
		<tr><td colspan="2">
			<table><tbody>
				<tr><td>
					<input id="rdoShowAll" type="radio" name="radio" onClick="showAllContexts();">Show all contexts</input>
				</td></tr>
				<tr><td>
					<input type="radio" name="radio" onClick="filterContexts();">Only</input>
				</td></tr>
				<tr><td>
					<select id="lstContexts" name="contexts" multiple="true" onChange="filterContexts();">
						<!--
						<option value="default">default</option>
						<option value="xml problems">xml problems</option>
						<option value="gui">gui</option>
						-->
					</select>
				</td></tr>
			</tbody></table>
		</td></tr>
		</tbody></table>
	<!-- End filter-->
	</td></tr>
	<tr><td>
		<!-- Start headers -->
		<table>
		<tbody>
		<tr>
			<td class='chatHeaders'><xsl:text>Log created: </xsl:text><xsl:value-of select='Created'/></td>
		</tr>
		<tr>
			<td class='chatHeaders'><xsl:text>Log last saved: </xsl:text><xsl:value-of select='LastSaved'/></td>
		</tr>
		</tbody>
		</table>
		<!-- End headers -->
	</td></tr>
	<tr><td class='msgDiv' id='sessionRow'>
		<!-- Start listing -->
		<xsl:for-each select='Sessions/no.jabber.eclipseplugin.serialization.LogSession'>
		<xsl:variable name='context'><xsl:value-of select='Context'/></xsl:variable>
			<xsl:for-each select='Messages'>
			<div msgDiv='yes'>
			<xsl:attribute name='context'><xsl:value-of select='$context'/></xsl:attribute>
				<div>
					<table class='chatLog' cellpadding='0'><tbody>
					<tr>
						<td>-</td><td class='plMiColumn' UNSELECTABLE='on'><img onClick='showHideChatSession();' onMouseEnter='mouseEnter();' onMouseLeave='mouseLeave();' src='-.gif'/></td>
						<td class='chatHeaders'>Context: <xsl:value-of select='$context'/>, Location: <xsl:value-of select='../ContextLocation'/>, <xsl:value-of select='no.jabber.eclipseplugin.serialization.LogEntry[count(no.jabber.eclipseplugin.serialization.LogEntry)]/Timestamp'/></td>
					</tr>
					</tbody></table>
				</div>
				<div class='msgDiv'>
				<table class='chatLog' cellpadding='0'><tbody>
					<xsl:for-each select='no.jabber.eclipseplugin.serialization.LogEntry'>
					<tr>
						<xsl:variable name='from'><xsl:value-of select='From'/></xsl:variable>
						<xsl:variable name='varMe'><xsl:text>$me</xsl:text></xsl:variable>
						<xsl:choose>
							<xsl:when test='$from=$varMe'><xsl:attribute name='class'>msgsFromMe</xsl:attribute></xsl:when>
						</xsl:choose>
						<td><xsl:value-of select='$from'/></td>
						<td align='right'><xsl:text>:</xsl:text></td>
						<td><xsl:attribute name='title'><xsl:text>Message received: </xsl:text><xsl:value-of select='Timestamp'/></xsl:attribute><xsl:value-of select='Msg'/></td>
					</tr>
					</xsl:for-each>
				</tbody></table>
				</div>
			</div>
			</xsl:for-each> <!-- messages -->
		</xsl:for-each> <!-- Sessions/no.jabber.eclipseplugin.serialization.LogSession -->
		<!-- End listing -->
	</td></tr>
</tbody></table>
</xsl:for-each> <!-- no.jabber.eclipseplugin.serialization.LogData -->
</body>
</html>
</xsl:template>
</xsl:stylesheet> 