package no.jabber.eclipseplugin;


/**
 * Various utility methods pertaining to XML/HTML operations
 */
public class XmlUtil
{
	public static String stringToHTMLString(String string)
	{
		StringBuffer sb = new StringBuffer(string.length());
		// true if last char was blank
		boolean lastWasBlankChar = false;
		int len = string.length();
		char c;
		for (int i = 0; i < len; i++)
		{
			c = string.charAt(i);
			if (c == ' ')
			{
				// blank gets extra work,
				// this solves the problem you get if you replace all
				// blanks with &nbsp;, if you do that you loss 
				// word breaking
				if (lastWasBlankChar)
				{
					lastWasBlankChar = false;
					//sb.append("&nbsp;");
					sb.append("&#160;");
				}
				else
				{
					lastWasBlankChar = true;
					sb.append(' ');
				}
			}
			else
			{
				lastWasBlankChar = false;
				// HTML Special Chars
				if (c == '"') sb.append("&quot;");
				else if (c == '&') sb.append("&amp;");
				else if (c == '<') sb.append("&lt;");
				else if (c == '>') sb.append("&gt;");
				//Handle Newline
				else if (c == '\n') sb.append("&lt;br/&gt;");
				else
				{
					int ci = 0xffff & c;
					// nothing special only 7 Bit
					if (ci < 160) sb.append(c);
					else
					{
						// Not 7 Bit use the unicode system
						sb.append("&#");
						sb.append(new Integer(ci).toString());
						sb.append(';');
					}
				}
			}
		}
		return sb.toString();
	}
}
