package no.jabber.eclipseplugin.decorators;

import org.eclipse.core.resources.IFile;
import org.eclipse.jface.viewers.IDecoration;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.ILightweightLabelDecorator;

import no.jabber.eclipseplugin.SimpleChatPlugin;
import no.jabber.eclipseplugin.Util;
import no.jabber.eclipseplugin.serialization.AwarenessEntry;

/**
 * Extension for decorating IFile objects with awareness info
 */
public class FileDecorator implements ILightweightLabelDecorator
{

	public void decorate(Object element, IDecoration decoration)
	{
		IFile file = (IFile) element;
		String strPath = file.getFullPath().toPortableString();
		if(SimpleChatPlugin.getDefault() != null)
		{
			AwarenessEntry[] aAwInfo = SimpleChatPlugin.getDefault().getLatestAwareness();
			if( (aAwInfo != null) && (aAwInfo.length > 0) )
			{
				for (int i = 0; i < aAwInfo.length; i++)
				{
					AwarenessEntry info = aAwInfo[i];
					if(info.getWhereAsEclipseLink().getPath().equals(strPath))
					{
						String strWho = Util.getUsernameFromEmail(Util.stripUserString(info.getWho()));
						decoration.addSuffix(" ("+strWho+")");
					}
				}
			}
		}
	}

	public void addListener(ILabelProviderListener listener){}

	public void dispose(){}

	public boolean isLabelProperty(Object element, String property)
	{
		return false;
	}

	public void removeListener(ILabelProviderListener listener){}
}