package no.jabber.eclipseplugin.dialogs;

import no.jabber.eclipseplugin.GuiUtil;
import no.jabber.eclipseplugin.Util.CustomEvent;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.graphics.FontMetrics;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

public class AdditionalInfoDialog extends Dialog
{

	private Shell sShell;
	private Text txt;
	public boolean bDontCloseOnExit = false;
	public CustomEvent<String> InfoUpdated = new CustomEvent<String>();
	private String strStartText = "";
	private String strNewText = "";
	
	/**
	 * Call this with new Shell()!
	 * @param shell
	 * @param style
	 */
	public AdditionalInfoDialog(Shell shell, int style)
	{
		super(shell, style);
		this.sShell = shell;
		this.sShell.addDisposeListener(new DisposeListener(){

			public void widgetDisposed(DisposeEvent e)
			{
				if(!strStartText.equalsIgnoreCase(strNewText)) InfoUpdated.fire(strNewText);
			}});
		
	}
	
	public boolean open(int x, int y, String strEmil,boolean bAdaptSize, int nWidth, int nHeight, String strTitle)
	{
		if(!this.sShell.isDisposed())
		{
			sShell.setText(strTitle);
			if(strEmil == null) strEmil = "";
			this.strStartText = strEmil;
			this.strNewText = this.strStartText;
			GC gc = new GC(sShell);
			FontMetrics fm = gc.getFontMetrics ();
			int nLines = 1;
			int ind = 0;
			int nLastInstance = strEmil.indexOf("\n", ind);
			while(nLastInstance > -1)
			{
				nLines++;
				ind = nLastInstance + 1;
				nLastInstance = strEmil.indexOf("\n", ind);
			}
			nLines += 3;
			Point ptShellSize = gc.textExtent(strEmil);
			ptShellSize.y = fm.getHeight() * nLines;
			gc.dispose();
			sShell.setSize(ptShellSize);
			GridLayout grd = new GridLayout(1,true);
			grd.marginHeight = 0;
			grd.marginWidth = 0;
			sShell.setLayout(grd);
			txt = new Text(sShell,SWT.MULTI);
			txt.setText(strEmil);
			txt.setLayoutData(GuiUtil.createFillGridData());
			txt.setEditable(true);
			txt.addModifyListener(new ModifyListener(){

				public void modifyText(ModifyEvent e)
				{
					strNewText = txt.getText();
				}});
			sShell.setLocation(x, y);
			Display display = this.sShell.getDisplay();
			this.sShell.open();
			while (!sShell.isDisposed())
			{
				if (!display.readAndDispatch()) display.sleep();
			}
			return true;
		}
		return false;
	}
}
