package no.jabber.eclipseplugin.dialogs;

import java.net.URISyntaxException;

import no.jabber.eclipseplugin.GuiUtil;
import no.jabber.eclipseplugin.Util;
import no.jabber.eclipseplugin.Util.CustomListener;
import no.jabber.eclipseplugin.linking.EclipseLink;
import no.jabber.eclipseplugin.serialization.LogSession;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.text.BadLocationException;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.forms.events.HyperlinkAdapter;
import org.eclipse.ui.forms.events.HyperlinkEvent;
import org.eclipse.ui.forms.widgets.Hyperlink;


public class PopupHyperlink extends HyperlinkAdapter
{
	enum HyperlinkType{SetLocation,SetAdditionalInfo};
	
	private LogSession session;
	private Hyperlink hl;
	private HyperlinkType ht;
	private AdditionalInfoDialog dlg;
	
	
	public PopupHyperlink(LogSession session, Hyperlink hl, final HyperlinkType ht)
	{
		this.session = session;
		this.hl = hl;
		this.ht = ht;
		hl.addMouseListener(new MouseListener(){

			public void mouseDoubleClick(MouseEvent e)
			{
				
			}

			public void mouseDown(MouseEvent e)
			{
				if(e.stateMask == SWT.CTRL) 
				{
					System.out.println("Ctrl");
					Shell sh = PopupShellFactory.getDefault().getEditableShell();
					openDlg(sh);
				}
				else
				{
					if(ht == HyperlinkType.SetAdditionalInfo) linkActivatedForMoreInfoHyperlink();
					else linkActivatedForLocationHyperlink();
				}
			}

			public void mouseUp(MouseEvent e){}
			});
	}
	
	private void openDlg(Shell sh)
	{
		String strEmil = session.getContextLocation();
		String strTitle = "Location";
		if(ht == HyperlinkType.SetAdditionalInfo)
		{
			strEmil = session.getMoreInfo();
			strTitle = "Additional Info";
		}
		dlg = new AdditionalInfoDialog(sh,SWT.NONE);
		dlg.InfoUpdated.addListener(new CustomListener<String>(){
			public void onAction(String strNewInfo)
			{
				if(ht == HyperlinkType.SetLocation)
				{
					session.setContextLocation(strNewInfo);
				}
				else
				{
					session.setMoreInfo(strNewInfo);
				}
			}});
		Point ptHlLoc = Display.getCurrent().map(hl.getParent(), null, hl.getLocation()); 
		dlg.open(ptHlLoc.x,ptHlLoc.y+hl.getBounds().height,strEmil,true,200,50,strTitle);
	}
	
//	public void linkEntered(HyperlinkEvent e){}

//	public void linkExited(HyperlinkEvent e){}

	public void linkActivated(HyperlinkEvent e)
	{
	}
	
	private void linkActivatedForMoreInfoHyperlink()
	{
//		if()
////		if( (dlg == null) || (dlg.isDialogShellDisposed()) ) 
////		{
//			Shell sh = PopupShellFactory.getDefault().getEditableShell();
//			System.out.println("link activated");
//			sh.addDisposeListener(new DisposeListener(){
//				public void widgetDisposed(DisposeEvent e)
//				{
//					bSuspendEvents = false;
//				}});
//			openDlg(sh);
//			dlg.setFocus();
////		}
////		dlg.bDontCloseOnExit = true;
	}
	
	private void linkActivatedForLocationHyperlink()
	{
//			//execute regular open eclipse link routine IF CTRL is pressed!
			try
			{
				String strHref = (String) hl.getHref();
				if(!Util.isStringEmpty(strHref,LogSession.DEFAULT_CONTEXT_LOCATION))
				{
					GuiUtil.openEditorForEclipseLink(new EclipseLink(strHref));
				}
			}
			catch (CoreException ex)
			{
				// TODO Auto-generated catch block
				ex.printStackTrace();
			}
			catch (BadLocationException ex)
			{
				// TODO Auto-generated catch block
				ex.printStackTrace();
			}
			catch (URISyntaxException ex)
			{
				// TODO Auto-generated catch block
				ex.printStackTrace();
			}
		}
}

