package no.jabber.eclipseplugin.dialogs;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Shell;

public class PopupShellFactory
{
	private static PopupShellFactory instance;
	
	public static PopupShellFactory getDefault()
	{
		if(instance == null) instance = new PopupShellFactory();
		return instance;
	}
	
	private PopupShellFactory(){};
	
	private Shell popupShell;
	
	public Shell getHoverShell(Shell parent)
	{
		this.disposeShell();
		this.popupShell = new Shell(parent, SWT.ON_TOP | SWT.TOOL | SWT.RESIZE); 
		return popupShell;
	}
	
	private void disposeShell()
	{
		if((popupShell != null) && (!popupShell.isDisposed()) ) 
		{
			this.popupShell.dispose();
		}
	}
	
	public Shell getEditableShell()
	{
		disposeShell();
		this.popupShell = new Shell(SWT.TOOL | SWT.RESIZE | SWT.CLOSE); 
		return popupShell;
	}
}
