package no.jabber.eclipseplugin.dialogs;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
/**
 * Dialog for entering info when adding user to roster.
 */
public class RosterEntryDialog extends Dialog
{
	private Text txtUser;
	private Text txtName;
	private String strUser;
	private String strName;
	private boolean bDisableUserInput = false;

	public RosterEntryDialog(Shell parentShell)
	{
		super(parentShell);
	}

	protected void configureShell(Shell newShell) 
	{
		super.configureShell(newShell);
		newShell.setText("Add contact");
	}

	public String getName()
	{
		return this.strName;
	}

	public void setName(String strName, boolean bEnable)
	{
		this.strName = strName;
	}

	public String getUser()
	{
		return this.strUser;
	}

	public void setUser(String strUser, boolean bDisableUserInput)
	{
		this.strUser = strUser;
		this.bDisableUserInput = bDisableUserInput;
	}
	
	public int open()
	{
		
		int nRet = super.open();
		return nRet;
	}
	
	protected Control createDialogArea(Composite parent) 
	{
		Composite composite = (Composite) super.createDialogArea(parent);
		composite.setLayout(new FormLayout());

		Label lblUser = new Label(composite, 0);
		FormData fm = new FormData();
		fm.left = new FormAttachment(composite,5,SWT.LEFT);
		fm.top = new FormAttachment(composite,5,SWT.TOP);
		lblUser.setLayoutData(fm);
		lblUser.setText("JabberID:");
		
		txtUser = new Text(composite, SWT.BORDER | SWT.SINGLE);
		FormData fm2 = new FormData();
		fm2.left = new FormAttachment(lblUser,5,SWT.RIGHT);
		fm2.top = new FormAttachment(composite,5,SWT.TOP);
		fm2.right = new FormAttachment(100,-5);
		txtUser.setLayoutData(fm2);

		Label lblName = new Label(composite, 0);
		FormData fm3 = new FormData();
		fm3.left = new FormAttachment(composite,5,SWT.LEFT);
		fm3.top = new FormAttachment(lblUser,12,SWT.BOTTOM);
		lblName.setLayoutData(fm3);
		lblName.setText("Name:");
		
		txtName = new Text(composite, SWT.BORDER | SWT.SINGLE);
		FormData fm4 = new FormData();
		fm4.left = new FormAttachment(lblName,21,SWT.RIGHT);
		fm4.top = new FormAttachment(txtUser,5,SWT.BOTTOM);
		fm4.right = new FormAttachment(100,-5);
		txtName.setLayoutData(fm4);
		
		if(this.strName != null) this.txtName.setText(strName);
		if(strUser != null) 
		{
			this.txtUser.setText(strUser);
			if(bDisableUserInput) this.txtUser.setEnabled(false);
		}
		
		return composite;
	}

	protected void createButtonsForButtonBar(Composite parent) 
	{
		createButton(parent, IDialogConstants.OK_ID,IDialogConstants.OK_LABEL,true);
		createButton(parent, IDialogConstants.CANCEL_ID, IDialogConstants.CANCEL_LABEL, false);
	}
	
	protected void buttonPressed(int buttonId) 
	{
		if (buttonId == IDialogConstants.CANCEL_ID)
			cancelPressed();
		else
		{
			this.strName = this.txtName.getText();
			this.strUser = this.txtUser.getText();
			if( (this.strName.length() == 0) || (this.strUser.length() == 0) ) MessageDialog.openError(this.getShell(), "Insufficient information", "One or more empty input.");
			else super.buttonPressed(buttonId);
		}
	}

	public boolean close() 
	{
		return super.close();
	}
}