package no.jabber.eclipseplugin.popup.actions;

import org.eclipse.core.resources.IFile;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.widgets.Event;
import org.eclipse.ui.IActionDelegate2;

import no.jabber.eclipseplugin.*;
import no.jabber.eclipseplugin.projectmanagement.Project;
import no.jabber.eclipseplugin.projectmanagement.ProjectConfig;

/**
 * This action is executed when a user wants to create a link from a IFile object using a right-click menu
 */
public class MakeLinkFromFileAction implements IActionDelegate2
{

	private IFile fileLatest;
	
	public void init(IAction action){}

	public void dispose(){}

	public void runWithEvent(IAction action, Event event)
	{
		if(fileLatest != null)
		{
			Project prj = ProjectConfig.getConfig().resolveProjectFromIProject(fileLatest.getProject());
			GuiUtil.createLinkFromFileAndInsert(fileLatest,prj);
		}
	}

	public void run(IAction action){}

	public void selectionChanged(IAction action, ISelection selection)
	{
		IStructuredSelection sel = (IStructuredSelection) selection;
		fileLatest = (IFile) sel.getFirstElement();
	}
}
