package no.jabber.eclipseplugin.popup.actions;

import java.net.URISyntaxException;

import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.widgets.Event;
import org.eclipse.ui.IActionDelegate2;
import no.jabber.eclipseplugin.*;
import no.jabber.eclipseplugin.linking.UnsupportedJavaElement;

/**
 * This action is executed when a user wants to create a link from a IJavaElement using a right-click menu
 * @author Arne Mathisen
 *
 */
public class MakeLinkFromJavaElementAction implements IActionDelegate2
{
	IJavaElement lastElement;
	
	public void run(IAction action){}

	public void selectionChanged(IAction action, ISelection selection)
	{
		IStructuredSelection sel = (IStructuredSelection) selection;
		lastElement = (IJavaElement) sel.getFirstElement();
	}

	public void init(IAction action){}

	public void dispose(){}

	public void runWithEvent(IAction action, Event event)
	{
		if(lastElement != null) try
		{
			GuiUtil.createLinkAndInsert(lastElement);
		}
		catch (URISyntaxException ex)
		{
			GuiUtil.handleException(ex, "There was an error in the link.");
		}
		catch (UnsupportedJavaElement ex)
		{
			GuiUtil.handleUnsupportedJavaElementException(ex);
		}
		
	}

}
