package no.jabber.eclipseplugin.popup.actions;

import no.jabber.eclipseplugin.GuiUtil;
import no.jabber.eclipseplugin.SimpleChatPlugin;
import no.jabber.eclipseplugin.linking.EclipseLink;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.text.ITextSelection;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IEditorActionDelegate;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IFileEditorInput;
import org.eclipse.ui.texteditor.ITextEditor;

/**
 * This action creates a link from the line number where the cursor is currently. Executed from a right-click menu.
 */
public class MakeLinkFromTextLineAction implements IEditorActionDelegate
{
	
	public void setActiveEditor(IAction action, IEditorPart targetEditor){}

	public void run(IAction action)
	{
		
		ITextEditor edtTxt = (ITextEditor)  GuiUtil.getCurrentEditor();
		int nLine = ((ITextSelection) edtTxt.getSelectionProvider().getSelection()).getEndLine();
		nLine++;
		EclipseLink eclLink = EclipseLink.createFromLineNumber(nLine,((IFileEditorInput) edtTxt.getEditorInput()).getFile());
		SimpleChatPlugin.getDefault().RequestPasteEclipseLink.fire(eclLink);
	}

	public void selectionChanged(IAction action, ISelection selection){}

}
