package no.jabber.eclipseplugin.popup.actions;



import no.jabber.eclipseplugin.SimpleChatPlugin;

import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IActionDelegate;
/**
 * This action sets the value of the context combobox to be the name of the currently selected IJavaElement. Executed from a right click menu.
 */
public class SetContextFromJavaElementAction implements IActionDelegate
{
	IJavaElement lastElement;
		
	public void selectionChanged(IAction action, ISelection selection)
	{
		IStructuredSelection sel = (IStructuredSelection) selection;
		if(sel != null)
		{
			lastElement = (IJavaElement) sel.getFirstElement();
		}
	}

	public void run(IAction action)
	{
		if(lastElement != null)
		{
			SimpleChatPlugin.getDefault().setContextFromMenu(lastElement.getElementName());
//			try
//			{
//				SimpleChatPlugin.getDefault().setContextLocationFromMenu(lastElement);
//			}
//			catch (URISyntaxException ex)
//			{
//				// TODO Auto-generated catch block
//				ex.printStackTrace();
//			}
		}
	}
}
