package no.jabber.eclipseplugin.popup.actions;


import no.jabber.eclipseplugin.SimpleChatPlugin;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.text.ITextSelection;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IEditorActionDelegate;
import org.eclipse.ui.IEditorPart;

/**
 * This action sets the value of the context combobox to be the name of the current text selection. Executed from a right click menu.
 */
public class SetContextFromTextAction implements IEditorActionDelegate
{
	String strLastSelection;
	
	public void setActiveEditor(IAction action, IEditorPart targetEditor){}
	
	public void run(IAction action)
	{
		if( (strLastSelection != null) && (strLastSelection.length() > 0) )
		{
			int nFirstWhiteSpace = strLastSelection.indexOf(" ");
			if(nFirstWhiteSpace == -1) 
			{
				SimpleChatPlugin.getDefault().setContextFromMenu(strLastSelection);
			}
		}
	}
	
	public void selectionChanged(IAction action, ISelection selection)
	{
		if( (selection != null) && (selection instanceof ITextSelection) )
		{
			ITextSelection sel = (ITextSelection) selection;
			strLastSelection = sel.getText();
		}
	}
}
