package no.jabber.eclipseplugin.popup.actions;

import java.net.URISyntaxException;

import no.jabber.eclipseplugin.GuiUtil;
import no.jabber.eclipseplugin.SimpleChatPlugin;
import no.jabber.eclipseplugin.linking.UnsupportedJavaElement;

import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IActionDelegate;

public class SetLocationFromJavaElementAction implements IActionDelegate
{

	IJavaElement lastElement;
	
	public void run(IAction action)
	{
		if(lastElement != null)
		{
//			SimpleChatPlugin.getDefault().setContextFromMenu(lastElement.getElementName());
			try
			{
				SimpleChatPlugin.getDefault().setContextLocationFromMenu(lastElement);
			}
			catch (URISyntaxException ex)
			{
				GuiUtil.handleException(ex, "There was an error in the link.");
			}
			catch (UnsupportedJavaElement ex)
			{
				GuiUtil.handleUnsupportedJavaElementException(ex);
			}
		}
	}

	public void selectionChanged(IAction action, ISelection selection)
	{
		IStructuredSelection sel = (IStructuredSelection) selection;
		if(sel != null)
		{
			lastElement = (IJavaElement) sel.getFirstElement();
		}
	}

}
