package no.jabber.eclipseplugin.preferences;

import no.jabber.eclipseplugin.SimpleChatPlugin;

import org.eclipse.jface.preference.*;
import org.eclipse.jface.util.*;
import org.eclipse.swt.widgets.*;
import org.eclipse.ui.*;

/**
 * Extension for the preference page.
 */
public class SimpleChatPreferencePage extends FieldEditorPreferencePage implements IWorkbenchPreferencePage
{
//	BooleanFieldEditor bfeGoogleTalk;
	StringFieldEditor sfeServer;
	StringFieldEditor sfePort;
	StringFieldEditor sfeUser;
	StringFieldEditor sfePass;


	public void init(IWorkbench workbench)
	{
	}	

	public void propertyChange(PropertyChangeEvent e)
	{
		super.propertyChange(e);
		this.checkState();
	}

	public SimpleChatPreferencePage()
	{
		super(FieldEditorPreferencePage.GRID);
		this.setPreferenceStore(SimpleChatPlugin.getDefault().getPreferenceStore());
		this.setTitle("SimpleChat");
	}

	protected void checkState()
	{
		Composite parent = getFieldEditorParent();
//		boolean b = !this.bfeGoogleTalk.getBooleanValue();
		this.sfeServer.setEnabled(true, parent);
		this.sfePort.setEnabled(true, parent);
		
		this.setValid(false);

//		if (!this.bfeGoogleTalk.getBooleanValue())
//		{
			if (this.sfeServer.getStringValue().length() == 0 || this.sfePort.getStringValue().length() == 0)
			{
				this.setErrorMessage("Missing one or more values!");
				return;
			}
			try
			{
				int nPort = Integer.parseInt((this.sfePort.getStringValue()));
				if (nPort < 0 || nPort > 65536) throw new Exception();
			}
			catch (Exception e)
			{
				this.setErrorMessage("Invalid port number!");
				return;
			}
//		}

		if (this.sfeUser.getStringValue().length() == 0)
		{
			this.setErrorMessage("Missing one or more values!");
			return;
		}

		this.setErrorMessage(null);
		this.setValid(true);
	}

	protected void createFieldEditors()
	{
		Composite parent = getFieldEditorParent();
//		this.bfeGoogleTalk = new BooleanFieldEditor(PreferenceConstants.P_GOOGLETALK, "Use GoogleTalk:", parent);
//		this.addField(bfeGoogleTalk);
		this.sfeServer = new StringFieldEditor(PreferenceConstants.P_SERVER, "Servername:", 40, parent);
		this.addField(this.sfeServer);
		this.sfePort = new StringFieldEditor(PreferenceConstants.P_PORT, "Port number:", 5, parent);
		this.sfePort.setTextLimit(5);
		this.addField(this.sfePort);
		this.sfeUser = new StringFieldEditor(PreferenceConstants.P_USER, "Username:", 40, parent);
		this.addField(this.sfeUser);
		this.sfePass = new StringFieldEditor(PreferenceConstants.P_PASS, "Password:", 40, parent);
		this.sfePass.getTextControl(parent).setEchoChar('*');
		this.addField(this.sfePass);
	}
}