// For future use!!
package no.jabber.eclipseplugin.projectmanagement;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Hashtable;
import java.util.Iterator;

import no.jabber.eclipseplugin.serialization.LogData;

//
//import java.util.Collection;
//import java.util.Hashtable;
//
//import no.jabber.eclipseplugin.awareness.AwarenessInfo;
//
//
public class Project
{
	private String CommonName;
	private String LocalMapping;
	private ArrayList<Contact> Members = new ArrayList<Contact>();;
	private transient LogData ld;
	
	public Project(LogData ld)
	{
		this.ld = ld;
	}
	public Project()
	{
		// TODO Auto-generated constructor stub
	}
	public String getCommonName()
	{
		return this.CommonName;
	}
	public void setCommonName(String strCommonName)
	{
		this.CommonName = strCommonName;
	}
	public String getLocalMapping()
	{
		return this.LocalMapping;
	}
	public void setLocalMapping(String strLocalMapping)
	{
		this.LocalMapping = strLocalMapping;
	}
	public Collection<Contact> getMembers()
	{
		return this.Members;
	}
	public void setMembers(Collection<Contact> collMembers)
	{
		this.Members = new ArrayList<Contact>(collMembers);
	}
	
	public String toString()
	{
		return this.CommonName;
	}
	
	/**
	 * Convenience when searching for member names, so the searching is not O(n^2)!
	 * @return Hashtable with membername as key AND value
	 */
	public Hashtable<String,Contact> getMembersInHt()
	{
		Hashtable<String,Contact> ht = new Hashtable<String, Contact>();
		if(Members != null)
		{
			for (Iterator iter = Members.iterator(); iter.hasNext();)
			{
				Contact c = (Contact)iter.next();
				ht.put(c.getFriendlyName(), c);
			}
//			for (int i = 0; i < Members.length; i++)
//			{
//				Contact c = Members[i];
//				ht.put(c.getName(), c);			
//			}
		}
		return ht;
	}
	public boolean hasMember(Contact contact)
	{
		for (Contact mem : Members)
		{
			if(mem.getUserName().equalsIgnoreCase(contact.getUserName())) return true;
		}
		return false;
	}
	public LogData getLogData()
	{
		return this.ld;
	}
	public void setLogData(LogData ld)
	{
		this.ld = ld;
	}
	
//	private Hashtable<String, AwarenessInfo> htAwarenessInfoByUser = new Hashtable<String, AwarenessInfo>();
//
//
//	// private Hashtable<IFile,AwarenessInfo[]> htAwarenessByFile = new
//	// Hashtable<IFile,AwarenessInfo[]>();
//
//	public Collection<AwarenessInfo> getAllAwarenessInfo()
//	{
//		return this.htAwarenessInfoByUser.values();
//	}
//
//	public void registerAwarenessInfo(AwarenessInfo awi)
//	{
//		this.htAwarenessInfoByUser.put(awi.getUser(), awi);
//	}
}