package no.jabber.eclipseplugin.resources;

import no.jabber.eclipseplugin.SimpleChatPlugin;

import org.eclipse.jface.resource.*;
import org.eclipse.swt.graphics.*;

/**
 * Collection for easily managing images.
 */
public class ImageCollection extends ResourceCollection<Image>
{
	// Singleton
	private static ImageCollection ic = new ImageCollection();
	public static ImageCollection getInstance() { return ic; }

	private ImageRegistry reg;
	private String strPath = "";

	private ImageCollection()
	{
		reg = SimpleChatPlugin.getDefault().getImageRegistry();
	}

	public String getPath()
	{
		return strPath;
	}

	public void setPath(String strPath)
	{
		this.strPath = strPath;
	}

	public void loadResource(String strID, String strFile)
	{
		if (this.get(strID) != null) return; // Ikke gjr noe som helst hvis bildet allerede er loada
		String strPlugin = SimpleChatPlugin.getDefault().getBundle().getSymbolicName();
		ImageDescriptor desc = SimpleChatPlugin.imageDescriptorFromPlugin(strPlugin, strPath + "/" + strFile);
		reg.put(strID, desc);
	}

	public void delete(String strID)
	{
		reg.remove(strID);
	}

	public Image get(String strID)
	{
		return reg.get(strID);
	}
}