package no.jabber.eclipseplugin.resources;

import java.util.Hashtable;

/**
 * Resource management abstract class
 */
public abstract class ResourceCollection<T>
{
	protected Hashtable<String, T> ht;


	protected ResourceCollection()
	{
		ht = new Hashtable<String, T>();
	}

	protected void add(String strID, T t)
	{
		ht.put(strID, t);
	}

	public T get(String strID)
	{
		return ht.get(strID);
	}

	public void delete(String strID)
	{
		ht.remove(strID);
	}


	public abstract void loadResource(String strID, String strFile);
}