package no.jabber.eclipseplugin.serialization;

import java.util.ArrayList;
import java.util.Date;

import no.jabber.eclipseplugin.Util;

/**
 * The root class for awareness data. Used for serializing and deserializing awareness log.
 */
@SuppressWarnings("unused")
public class AwarenessData
{
	private String Created;
	private String LastSaved;
	private ArrayList<AwarenessSession> Sessions = new ArrayList<AwarenessSession>();


	public AwarenessData()
	{
		this.Created = Util.getDateFormatter().format(new Date());
		this.createNewSession();
	}

	public AwarenessSession createNewSession()
	{
		AwarenessSession as = new AwarenessSession(this);
		Sessions.add(as);
		return as;
	}

	public String getLastSaved()
	{
		if(this.LastSaved == null) this.LastSaved = "";
		return this.LastSaved;
	}

	public void setLastSaved(String lastSaved)
	{
		this.LastSaved = lastSaved;
	}

	public ArrayList<AwarenessSession> getSessions()
	{
		return Sessions;
	}

	public void setSessions(ArrayList<AwarenessSession> sessions)
	{
		Sessions = sessions;
	}

	public AwarenessSession getLatestSession()
	{
		return this.Sessions.get(Sessions.size() - 1);
	}
}