package no.jabber.eclipseplugin.serialization;

import java.util.ArrayList;

import no.jabber.eclipseplugin.linking.EclipseLink;

/**
 * A single awareness information message. Used for serializing and deserializing awareness log.
 */
@SuppressWarnings("unused")
public class AwarenessEntry
{
	private String Who;
	private String Where;
	private transient EclipseLink eclWhere;
	private String When;
	private ArrayList<String> What = new ArrayList<String>();


	public AwarenessEntry(String strWho, EclipseLink eclWhere, String strWhen, ArrayList<String> alWhat)
	{
		this.Who = strWho;
		this.eclWhere = eclWhere;
		this.Where = eclWhere.getLinkAsString()+" ";
		this.When = strWhen;
		this.What = alWhat;
	}
	
	public EclipseLink getWhereAsEclipseLink()
	{
		return this.eclWhere;
	}

	public String getWho()
	{
		return this.Who;
	}

	public void setWho(String strWho)
	{
		this.Who = strWho;
	}

	public String getWhere()
	{
		return this.Where;
	}

	public void setWhere(EclipseLink eclWhere)
	{
		this.Where = eclWhere.getLinkAsString();
	}

	public String getWhen()
	{
		return this.When;
	}

	public void setWhen(String strWhen)
	{
		this.When = strWhen;
	}

	public ArrayList<String> getWhat()
	{
		return What;
	}

	public void setWhat(ArrayList<String> alWhat)
	{
		What = alWhat;
	}
}