package no.jabber.eclipseplugin.serialization;

import java.util.*;

import no.jabber.eclipseplugin.Util;
import no.jabber.eclipseplugin.linking.EclipseLink;

/**
 * Represents a single awareness session. Used for serializing and deserializing awareness log.
 */
@SuppressWarnings("unused")
public class AwarenessSession
{
	private transient AwarenessData parent;
	private ArrayList<AwarenessEntry> Entries = new ArrayList<AwarenessEntry>();

	public AwarenessSession(AwarenessData parent)
	{
		this.parent = parent;
	}

	public String getLatestTimestamp()
	{
		return this.Entries.get(Entries.size() - 1).getWhen();
	}

	public ArrayList<AwarenessEntry> getEntries()
	{
		return this.Entries;
	}

	public void setEntries(ArrayList<AwarenessEntry> entries)
	{
		Entries = entries;
	}

	public AwarenessData getParent()
	{
		return parent;
	}

	public void setParent(AwarenessData parent)
	{
		this.parent = parent;
	}

	public AwarenessEntry addMessage(String strWho, EclipseLink eclWhere, String strWhen, String strParam1, String strParam2, String strParam3)
	{
		return this.addMessage(strWho, eclWhere, strWhen, Util.createArrayList(strParam1, strParam2, strParam3));
	}

	public AwarenessEntry addMessage(String strWho, EclipseLink eclWhere, String strWhen, ArrayList<String> alWhat)
	{
		AwarenessEntry entry = new AwarenessEntry(strWho, eclWhere, strWhen, alWhat);
		this.Entries.add(entry);
		return entry;
	}
}