package no.jabber.eclipseplugin.tests;

import java.util.ArrayList;
import java.util.Date;

import no.jabber.eclipseplugin.serialization.AwarenessData;
import no.jabber.eclipseplugin.serialization.AwarenessSession;
import junit.framework.Assert;
import junit.framework.TestCase;

public class AwarenessDataTests extends TestCase
{

	public AwarenessDataTests(String name)
	{
		super(name);
	}

	protected void setUp() throws Exception
	{
		super.setUp();
	}

	protected void tearDown() throws Exception
	{
		super.tearDown();
	}

	/*
	 * Test method for 'no.jabber.eclipseplugin.serialization.AwarenessData.AwarenessData()'
	 */
	public final void testAwarenessData()
	{
		AwarenessData ad = new AwarenessData();
		Assert.assertNotNull(ad);
	}

	/*
	 * Test method for 'no.jabber.eclipseplugin.serialization.AwarenessData.createNewSession()'
	 */
	public final void testCreateNewSession()
	{
		AwarenessData ad = new AwarenessData();
		Assert.assertNotNull(ad);
		int nSize = ad.getSessions().size();
		ad.createNewSession();
		int nNewSize = ad.getSessions().size();
		Assert.assertTrue((nNewSize - nSize) == 1);
	}

	/*
	 * Test method for 'no.jabber.eclipseplugin.serialization.AwarenessData.getLastSaved()'
	 */
	public final void testGetLastSaved()
	{
		AwarenessData ad = new AwarenessData();
		String str = ad.getLastSaved();
		Assert.assertNotNull(str);
	}

	/*
	 * Test method for 'no.jabber.eclipseplugin.serialization.AwarenessData.setLastSaved(String)'
	 */
	public final void testSetLastSaved()
	{
		AwarenessData ad = new AwarenessData();
		String str = new Date().toString();
		ad.setLastSaved(str);
		String str2 = ad.getLastSaved();
		Assert.assertEquals(str, str2);
	}

	/*
	 * Test method for 'no.jabber.eclipseplugin.serialization.AwarenessData.getSessions()'
	 */
	public final void testGetSessions()
	{
		AwarenessData ad = new AwarenessData();
		Assert.assertNotNull(ad);
		ArrayList<AwarenessSession> als = ad.getSessions();
		Assert.assertNotNull(als);
	}

	/*
	 * Test method for 'no.jabber.eclipseplugin.serialization.AwarenessData.setSessions(ArrayList<AwarenessSession>)'
	 */
	public final void testSetSessions()
	{
		AwarenessData ad = new AwarenessData();
		Assert.assertNotNull(ad);
		ArrayList<AwarenessSession> als = new ArrayList<AwarenessSession>();
		ad.setSessions(als);
		ArrayList<AwarenessSession> als2 = ad.getSessions();
		Assert.assertEquals(als, als2);
	}

	/*
	 * Test method for 'no.jabber.eclipseplugin.serialization.AwarenessData.getLatestSession()'
	 */
	public final void testGetLatestSession()
	{
		AwarenessData ad = new AwarenessData();
		Assert.assertNotNull(ad);
		AwarenessSession as = ad.createNewSession();
		Assert.assertNotNull(as);
		AwarenessSession asLatest = ad.getLatestSession();
		Assert.assertEquals(as, asLatest);

	}

}
